// u_26_getenumname
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_26_getenumname;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    display_align_: TButton;
    display_align_recursive_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure display_align_Click(Sender: TObject);
    procedure display_align_recursive_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
    uses TypInfo, u_display_simple;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    function f_display_align(p_align: tAlign): String;
      begin
        Result:= GetEnumName(TypeInfo(tAlign), Integer(p_align));
      end; // f_display_align

    procedure display_control_alignment_recursive(p_level: integer; p_c_wincontrol: tWinControl);
      var l_control_index: Integer;
          l_c_control: tControl;
      begin
        for l_control_index:= 0 to p_c_wincontrol.ControlCount- 1 do
        begin
          l_c_control:= p_c_wincontrol.Controls[l_control_index];
          with l_c_control do
            display(Format('%'+ IntToStr(p_level)+ 's %-31s %s', ['', Name, f_display_align(Align)]));

          if l_c_control is tWinControl then
            display_control_alignment_recursive(p_level+ 2, l_c_control as tWinControl);
        end; // for l_control_index
      end; // display_control_alignment_recursive

    procedure TForm1.display_align_Click(Sender: TObject);
      var l_control_index: Integer;
      begin
        for l_control_index:= 0 to ControlCount- 1 do
          with Controls[l_control_index] do
            display(Format('%-21s %s', [Name, f_display_align(Align)]));
      end; // display_align_Click

    procedure TForm1.display_align_recursive_Click(Sender: TObject);
      begin
        display('');
        display_control_alignment_recursive(0, Self);
      end; // display_align_recursive_Click


end.
